<?php
//require_once( 'field-validators/ValidatorFactory.php');

class FieldValidatorAction extends Action
{

//NOT used by Femtoo.
// BUT used by SupplierBox and Jivewall.

/*
	public static $validatorClassMap = array( 
			'user_email' => 'UserEmailValidator',
			'tracker_url' => 'UniqueTrackerValidator'
	);*/

	function FieldValidatorAction() {
	}

	public function performAction( $pathParts, &$dataCollector, $requestPath)
	{
		$validatorType = requestParam('type');

/*
		$fieldId = $this->getRequestParam('fieldId');
		$validationFieldType = $this->getRequestParam('validationFieldType');
*/
		if( isset( $validatorType) && !empty( $validatorType) ){
			//THIS should all be done inside Contentigo::loadValidator:
			global $site;
			if( array_key_exists( CSM_FIELD_VALIDATORS, $site) && !empty( $site[ CSM_FIELD_VALIDATORS]) ) {
				//no field validators are defined, not much we can do:
//			if( array_key_exists( $validatorType, FieldValidatorAction::$validatorClassMap) ) {
				//ok lets try and create the validator and validate something:
				
				if( array_key_exists($validatorType, $site[ CSM_FIELD_VALIDATORS]) && !empty( $site[ CSM_FIELD_VALIDATORS][ $validatorType])) {
					//good, we have a configured validator name:
					$validatorClassName = $site[ CSM_FIELD_VALIDATORS][ $validatorType];
					$fieldValidator = loadValidator( $validatorClassName);
					
//					logVar( requestParam('args'));
					$args = requestParam('args');
//					$args = json_decode( requestParam('args'), true);
			//		$escapedArgs = $model->removeSlashes( $this->getRequestParam('args') );
			//		$args = json_decode( $escapedArgs, true);
					$fieldValue = requestParam('fieldValue');
	
					$fieldDefinitionArray = array();
					//$message = $validator->validate( $fieldDefinitionArray, $fieldValue);
					$message = $fieldValidator->validate( $fieldValue, $args);
	
					//should use JSON. 
					//$model->displayDataMap['text'] = $message;
	
					//$dataCollector['raw'] = $message;
					//return array( 'status' => SUCCESS);
					
					echo $message;
					exit;
				} else {
					//validator not listed in $site
				}
				
			}
		}

//		$dataCollector['raw'] = '{"isValid":false,"reason":"validator_not_found"}';
//		return array( 'status' => SUCCESS);
		echo '{"isValid":false,"reason":"validator_not_found"}';
		exit;
	}

}
?>